<?php
add_shortcode( 'modus_box', 'modus_tp_advanced_box' );
function modus_tp_advanced_box( $atts, $content=null ){
    extract( shortcode_atts(
        array(
            'layout'        => 'layout1',
            'type'          => 'style1',
            'bt_link_show'  => 'show',
            'badges_ct1'  	=> '',
            'badges_ct2'  	=> '',
            'title'         => '',
            'sub_title'     => '',
            'image'         => '',
            'link'          =>'',
            'el_class'      => '',
            'css'           => '',
        ),$atts ));
    ob_start();
    $content = wpb_js_remove_wpautop( $content, true );
    $css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, vc_shortcode_custom_css_class( $css, '' ), 'modus_box', $atts );
    $el_class = modus_extract_class( $el_class ).' '.$css_class;

    //parse link
    $link = ( '||' == $link ) ? '' : $link;
    $link = vc_build_link($link);
    $has_link = false;
    $a_link = '';
    $a_title = $a_target =' ';
    if ( strlen( $link['url'] ) > 0 ){
        $has_link = true;
        $a_link = $link['url'];
        $a_title = $link['title'];
        $a_target = ( strlen($link['target']) > 0 ) ? $link['target'] : '_self';
    }
    ?>
    <div class="modus-box<?php echo esc_attr( $el_class ); ?>">
        <div class="<?php echo esc_attr( $layout); ?> <?php echo esc_attr( $type );?>">
            <?php if ( $layout == 'layout1' ) : 
                if ( $type == 'style1' || $type == 'style4'):
                    if ( $image !='' ):
                        $images = wp_get_attachment_image_src( $image, 'full' );
						if( $a_link != '' ) echo '<a href="'. esc_attr( $a_link ).'" title="'. esc_attr( $a_title ).'" target="'. esc_attr( $a_target ).'" >';
                    ?>
                    <div class="box-image sfc wow fadeInUp" data-wow-duration="300ms" data-wow-delay="100ms">
                        <img alt="icon" src="<?php echo esc_url( $images[0] ); ?>">
                    </div>
                    <?php
						if( $a_link != '' ) echo '</a>';
                    endif;
                    ?>
                    <div class="box-content">
                        <div class="title-box sfc wow fadeInUp" data-wow-duration="400ms" data-wow-delay="100ms">
                            <?php if ( $sub_title != '' ) : ?><h4 class="boxsub-title"><?php echo wp_kses_post( $sub_title );?></h4><?php endif;?>
                            <?php if ( $title != '' ) : ?><h3 class="box-title"><?php echo wp_kses_post( $title );?></h3><?php endif;?> 
                        </div>
                        <?php if ( $content != '' ) : ?>
                        <div class="text-ct  sfc wow fadeInUp" data-wow-duration="450ms" data-wow-delay="100ms"><?php echo $content;?></div>

                        <?php endif; ?>
                        <?php
                            if( $a_link != '' ) :
                            ?>
                            <a class="link-more sfc wow fadeInUp" data-wow-duration="500ms" data-wow-delay="100ms" href="<?php echo esc_attr( $a_link ); ?>" title="<?php echo esc_attr( $a_title ); ?>" target="<?php echo esc_attr( $a_target ); ?>" ><?php echo esc_attr( $a_title ); ?></a>
                            <?php 
                            endif; 
                        ?>
                    </div>
                <?php 
                elseif ( $type == 'style2' ):
                    if ( $image !='' ):
                        $images = wp_get_attachment_image_src( $image, 'full' );
                    ?>
                    <div class="box-image">
						<?php if( $a_link != '' ) echo '<a href="'. esc_attr( $a_link ).'" title="'. esc_attr( $a_title ).'" target="'. esc_attr( $a_target ).'" >'; ?>
                        <img alt="icon" src="<?php echo esc_url( $images[0] ); ?>">
						<?php if( $a_link != '' ) echo '</a>'; ?> 
                        <div class="box-content<?php if( $bt_link_show == 'hidden' ) echo ' text-center';?>">
                            <div class="title-box">
                                <?php if ( $title != '' ) : ?><h3 class="box-title"><?php echo wp_kses_post( $title );?></h3><?php endif;?>
                                <?php if ( $sub_title != '' ) : ?><h4 class="boxsub-title"><?php echo wp_kses_post( $sub_title );?></h4><?php endif;?>
                            </div>
                            <?php
                                if( $a_link != '' && $bt_link_show == 'show' ) :
                                ?>
                                <a class="link-more" href="<?php echo esc_attr( $a_link ); ?>" title="<?php echo esc_attr( $a_title ); ?>" target="<?php echo esc_attr( $a_target ); ?>" ><i class="fa fa-angle-right" aria-hidden="true">&nbsp;</i></a>
                                <?php 
                                endif; 
                            ?>
                        </div>
                    </div>
                    <?php
                    endif;
                    ?>
                    <?php
                elseif ( $type == 'style3') :
                    if ( $image !='' ):
                        $images = wp_get_attachment_image_src( $image, 'full' );
                    ?>
                    <div class="box-image">
						<?php if( $a_link != '' ) echo '<a href="'. esc_attr( $a_link ).'" title="'. esc_attr( $a_title ).'" target="'. esc_attr( $a_target ).'" >'; ?>
                        <img alt="icon" src="<?php echo esc_url( $images[0] ); ?>">
						<?php if( $a_link != '' ) echo '</a>'; ?>
                    </div>
                    <?php
                    endif;
                    ?>
                    <div class="box-content">
                        <div class="title-box">
                            <?php if ( $title != '' ) : ?><h3 class="box-title"><?php echo wp_kses_post( $title );?></h3><?php endif;?>
                            <?php if ( $sub_title != '' ) : ?><h4 class="boxsub-title"><?php echo wp_kses_post( $sub_title );?></h4><?php endif;?>
                        </div>
                        <?php if ( $content != '' ) : ?>
                        <div class="text-ct"><?php echo $content;?></div>
                        <?php endif; ?>
                        <?php
                            if( $a_link != '' ) :
                        ?>
                            <a class="link-more" href="<?php echo esc_attr( $a_link ); ?>" title="<?php echo esc_attr( $a_title ); ?>" target="<?php echo esc_attr( $a_target ); ?>" ><i class="fa fa-angle-right" aria-hidden="true">&nbsp;</i></a>
                        <?php 
                            endif; 
                        ?>
                    </div>
                <?php 
                endif; 
            elseif ( $layout == 'layout2' ) : ?>
                <div class="box2">
                    <?php
                        if ( $image !='' ):
                            $images = wp_get_attachment_image_src( $image, 'full' );
                        ?>
                            <img alt="icon" src="<?php echo esc_url( $images[0] ); ?>">
                        <?php
                        endif;
                    ?>
                    <div class="midle">
                        <div class="box-content">
                            <div class="title-box">
                                <?php if ( $sub_title != '' ) : ?><h4 class="boxsub-title"><?php echo wp_kses_post( $sub_title );?></h4><?php endif;?>
                                <?php if ( $title != '' ) : ?><h3 class="box-title"><?php echo wp_kses_post( $title );?></h3><?php endif;?>
                            </div>
                            <div class="text-ct"><?php echo $content;?></div>
                        </div>
                        <?php
                            if( ($a_title != '') && ($a_link != '') ) :
                            ?>
                            <a class="link-more hvr-rectangle-out" href="<?php echo esc_attr( $a_link ); ?>" title="<?php echo esc_attr( $a_title ); ?>" target="<?php echo esc_attr( $a_target ); ?>" ><?php echo esc_attr( $a_title ); ?></a>
                            <?php 
                            endif; 
                        ?>
                    </div>
                </div>
            <?php elseif ( $layout == 'layout3' ) : ?>
                <div class="box3 <?php echo esc_attr( $type );?>">
                    <div class="box-content">
                        <div class="title-box sfc wow fadeInUp" data-wow-duration="300ms" data-wow-delay="100ms">
                            <?php if ( $title != '' ) : ?><h3 class="box-title"><?php echo wp_kses_post( $title );?></h3><?php endif;?>
                        </div>
                        <div class="text-ct sfc wow fadeInUp" data-wow-duration="400ms" data-wow-delay="100ms"><?php echo $content;?></div>
                    </div>
                    <?php
                        if( ($a_title != '') && ($a_link != '') ) :
                        ?>
                        <a class="link-more hvr-rectangle-out sfc wow fadeInUp" data-wow-duration="450ms" data-wow-delay="100ms" href="<?php echo esc_attr( $a_link ); ?>" title="<?php echo esc_attr( $a_title ); ?>" target="<?php echo esc_attr( $a_target ); ?>" ><?php echo esc_attr( $a_title ); ?></a>
                        <?php 
                        endif; 
                    ?>
                </div>
            <?php elseif ( $layout == 'layout4' ) :
				echo '<div class="box-image">';
				if ( $image !='' ):
					$images = wp_get_attachment_image_src( $image, 'full' );
					if( $a_link != '' ) echo '<a href="'. esc_attr( $a_link ).'" title="'. esc_attr( $a_title ).'" target="'. esc_attr( $a_target ).'" >';
				?>
					<img alt="icon" src="<?php echo esc_url( $images[0] ); ?>">
				<?php
					if( $a_link != '' ) echo '</a>';
				endif;
				?>
				<div class="box-content">
					<div class="title-box">
						<?php if ( $sub_title != '' ) : ?><h4 class="boxsub-title"><?php echo wp_kses_post( $sub_title );?></h4><?php endif;?>
						<?php if ( $title != '' ) : ?><h3 class="box-title"><?php echo wp_kses_post( $title );?></h3><?php endif;?>
					</div>
					<?php if ( $badges_ct1 != '' || $badges_ct2 != '' ) : ?>
					<div class="text-ct"><?php echo '<span>'. $badges_ct1 .'</span> '. $badges_ct2 ?></div>
					<?php endif; ?>
					<?php
						if( $a_link != '' ) :
						?>
						<a class="link-more"  href="<?php echo esc_attr( $a_link ); ?>" title="<?php echo esc_attr( $a_title ); ?>" target="<?php echo esc_attr( $a_target ); ?>" ><?php echo esc_attr( $a_title ); ?></a>
						<?php 
						endif; 
					?>
				</div>
				
			<?php 
				echo '</div>';
				endif; 
			?>
			
		</div>
    </div>
    <?php
    return ob_get_clean();
}
?>