<?php
add_shortcode( 'modus_testimonial', 'modus_tp_testimonial' );
function modus_tp_testimonial( $atts ){
    extract( shortcode_atts(
        array(
            'title' => '',
            'layout' => 'layout1',
            'items_show' => -1,
            'hidden_job' => '',
            'el_class' => '',
            'css' => '',
        ),$atts ));
    ob_start();

    $css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, vc_shortcode_custom_css_classs( $css, '' ), 'modus_testimonial', $atts );
    $el_class = modus_extract_class( $el_class );
    if ( $css_class != '' ){
        $el_class .= modus_extract_class( $css_class );
    }
    ?>
    <div class="modus-testi<?php echo $el_class; ?>">
        <div class="sfc wow fadeInUp" data-wow-duration="300ms" data-wow-delay="100ms">
            <?php if ( $title != '' ) : ?>
                <div class="modus-headingtitle md">
                    <div class="shortcode-title text-left">
                        <h2><?php echo wp_kses_post( $title );?></h2>
                    </div>
                </div>
            <?php endif; ?>
            <?php
            if ( $items_show < 0 ){
                $args = array(
                    'post_type' => 'testimonial',
                    'post_status' => 'publish',
                    'posts_per_page' => -1,
                );
            }else{
                $args = array(
                    'post_type' => 'testimonial',
                    'post_status' => 'publish',
                    'posts_per_page' => $items_show,
                );
            }

            $rquery = New Wp_Query( $args );
            if ( $rquery -> have_posts() ) :
                if( $layout != 'layout6' || $layout != 'layout10' ) : ?>
                <div class="slide-testimonial initSlide_product <?php echo esc_attr( $layout );?>" data-columns="1">
                    <div class="beans-stepslider" data-rotate="true">
                        <div class="beans-mask">
                            <div class="beans-slideset">
                                <?php
                                $col = 0;
                                while ( $rquery -> have_posts() ) : $rquery -> the_post();
                                    if( $layout == 'layout1' ) {
                                        ?>
                                        <div class="beans-slide">
                                            <?php if ( has_post_thumbnail() ) : ?>
                                                <?php the_post_thumbnail( 'full' );?>
                                            <?php else : ?>
                                                <div class="boxtm-img"></div>
                                            <?php endif; ?>
                                            <div class="txt">
                                                <?php echo modus_content_limit(25); ?>
                                            </div>
                                            <div class="testiImg">
                                                <div class="info">
                                                    <h3><?php the_title(); ?></h3>
                                                    <?php if ( $hidden_job != 'enable_hidden_job' ) : ?><span><?php echo get_post_meta( get_the_ID(), 'business', true );?></span> <?php endif; ?>
                                                </div>
                                            </div>
                                        </div>
                                        <?php }
                                    else if( $layout == 'layout2' ) {
                                        ?>
                                        <div class="beans-slide">
                                            <?php if ( has_post_thumbnail() ) : ?>
                                                <?php the_post_thumbnail( 'full' );?>
                                            <?php else : ?>
                                                <div class="boxtm-img"></div>
                                            <?php endif; ?>
                                            <div class="txt">
                                                <div class="info">
                                                    <h3><?php the_title(); ?><span>&nbsp;</span></h3>
                                                </div>
                                                <?php the_content(); ?>
                                            </div>
                                        </div>
                                        <?php }
                                   else if( $layout == 'layout3' ) {
                                        ?>
                                        <div class="beans-slide">
                                            <div class="row text-left">
                                                <div class="col-md-3 col-sm-5 col-xs-12">
                                                    <div class="width40">
                                                        <?php if ( has_post_thumbnail() ) : ?>
                                                            <?php the_post_thumbnail( 'modus-image-80' );?>
                                                        <?php else : ?>
                                                            <div class="boxtm-img"></div>
                                                        <?php endif; ?>
                                                    </div>
                                                    <div class="width60">
                                                        <div class="info">
                                                            <h3><?php the_title(); ?><span>&nbsp;</span></h3>
                                                            <span><?php echo get_post_meta( get_the_ID(), 'business', true );?></span>
                                                            <div class="line-white"></div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="col-md-9 col-sm-7 col-xs-12 xs-padding-top-20">
                                                    <div class="txt">
                                                        <?php the_content(); ?>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <?php }
                                    else if( $layout == 'layout4' ) {
                                        ?>
                                        <div class="beans-slide">
                                            <?php if ( has_post_thumbnail() ) : ?>
                                                <?php the_post_thumbnail( 'full' );?>
                                            <?php else : ?>
                                                <div class="boxtm-img"></div>
                                            <?php endif; ?>
                                            <div class="txt">
                                                <?php if ( has_excerpt()) the_excerpt();
                                                       else  echo modus_content_limit(25);
                                                ?>
                                            </div>
                                            <div class="testiImg">
                                                <div class="info">
                                                    <h3><?php the_title(); ?></h3>
                                                    <?php if ( $hidden_job != 'enable_hidden_job' ) : ?><span> - <?php echo get_post_meta( get_the_ID(), 'business', true );?></span> <?php endif; ?>
                                                </div>
                                            </div>
                                        </div>
                                        <?php }
                                    else if( $layout == 'layout5' ) {
                                        ?>
                                        <div class="beans-slide">
                                            <div class="text-left relative">
                                                <?php if ( has_post_thumbnail() ) : ?>
                                                    <div class="img-test">
                                                        <?php the_post_thumbnail( 'full' );?>
                                                    </div>
                                                <?php else : ?>
                                                    <div class="boxtm-img"></div>
                                                <?php endif; ?>
                                                <div class="info">
                                                    <h3><?php the_title(); ?></h3>
                                                    <?php if ( $hidden_job != 'enable_hidden_job' ) : ?><span><?php echo get_post_meta( get_the_ID(), 'business', true );?></span> <?php endif; ?>
                                                </div>
                                                <div class="txt">
                                                    <?php echo modus_content_limit(25); ?>
                                                </div>
                                            </div>
                                        </div>
                                        <?php }
                                    else if( $layout == 'layout7' ){
                                        ?>
                                        <div class="beans-slide">
                                            <div class="item-type7 text-left relative">
                                                <?php if ( has_post_thumbnail() ) : ?>
                                                    <div class="img-test">
                                                        <?php the_post_thumbnail( 'full' );?>
                                                    </div>
                                                <?php else : ?>
                                                    <div class="boxtm-img"></div>
                                                <?php endif; ?>
                                                <div class="txt">
                                                    <?php echo modus_content_limit(25); ?>
                                                </div>
                                                <div class="info">
                                                    <h3><?php the_title(); ?> -
                                                    <?php if ( $hidden_job != 'enable_hidden_job' ) : ?><span><?php echo get_post_meta( get_the_ID(), 'business', true );?></span> <?php endif; ?></h3>
                                                </div>
                                            </div>
                                        </div>
                                        <?php }
                                    else if( $layout == 'layout8' ){
                                        ?>
                                        <div class="beans-slide">
                                            <div class="item-type8 text-left relative">
                                                <?php if ( has_post_thumbnail() ) : ?>
                                                    <div class="img-test">
                                                        <?php the_post_thumbnail( 'full' );?>
                                                    </div>
                                                <?php else : ?>
                                                    <div class="boxtm-img"></div>
                                                <?php endif; ?>

                                                <div class="info">
                                                    <h3><?php the_title(); ?></h3>
                                                </div>
                                                <div class="txt">
                                                    <?php echo modus_content_limit(25); ?>
                                                </div>
                                            </div>
                                        </div>
                                        <?php }
                                    else if( $layout == 'layout9' ) {
                                        ?>
                                        <div class="beans-slide">
                                            <div class="item-type7 text-left relative">
                                                <?php if ( has_post_thumbnail() ) : ?>
                                                    <div class="img-test">
                                                        <?php the_post_thumbnail( 'full' );?>
                                                    </div>
                                                <?php else : ?>
                                                    <div class="boxtm-img"></div>
                                                <?php endif; ?>
                                                <div class="txt">
                                                    <?php echo modus_content_limit(15); ?>
                                                </div>
                                                <div class="info">
                                                    <h3><?php the_title(); ?> -
                                                    <?php if ( $hidden_job != 'enable_hidden_job' ) : ?><span><?php echo get_post_meta( get_the_ID(), 'business', true );?></span> <?php endif; ?></h3>
                                                </div>
                                            </div>
                                        </div>
                                        <?php }
                                endwhile;
                                wp_reset_postdata();
                                ?>
                            </div>
                        </div>
                        <?php
                        if ( ($layout == 'layout4') || ($layout == 'layout5') || ($layout == 'layout8') ){?>
                            <a class="btn-prev" href="#"><i class="fa fa-angle-left"></i></a>
                            <a class="btn-next" href="#"><i class="fa fa-angle-right"></i></a>
                        <?php }else { ?>
                                <div class="beans-pagination">
                                    <!-- pagination generated here -->
                                </div>
                        <?php } ?>
                    </div>
                </div>
                <?php
                endif;
                if( $layout == 'layout6' ) :
                    while ( $rquery -> have_posts() ) : $rquery -> the_post();
                        ?>
                        <div class="item-list">
                            <div class="text-left relative">
                                <?php
                                $title = get_post_meta( get_the_ID(), 'testimonial-title', true );
                                if ( $title != '' ) :
                                    ?>
                                    <div class="title"><i class="pe-7f-chat"></i><h2><?php echo get_post_meta( get_the_ID(), 'testimonial-title', true ); ?></h2></div>
                                    <?php
                                    endif;
                                ?>
                                <div class="txt">
                                    <?php the_content(); ?>
                                </div>
                                <div class="info">
                                    <h3><?php the_title(); ?> -
                                    <?php if ( $hidden_job != 'enable_hidden_job' ) : ?><span><?php echo get_post_meta( get_the_ID(), 'business', true );?></span> <?php endif; ?></h3>
                                    <?php if ( has_post_thumbnail() ) : ?>
                                        <div class="img-test">
                                            <?php the_post_thumbnail( 'full' );?>
                                        </div>
                                    <?php endif; ?>
                                </div>

                            </div>
                        </div>
                        <?php
                    endwhile;
                endif;?>

                <?php
                if ($layout=='layout10'):?>
                    <div class="slide-testimonial initSlide_product <?php echo esc_attr( $layout );?>" data-columns="2">
                        <div class="beans-stepslider" data-rotate="true">
                            <div class="beans-mask">
                                <div class="beans-slideset">
                                    <?php
                                    $col = 0;
                                    while ( $rquery -> have_posts() ) : $rquery -> the_post();?>
                                        <div class="beans-slide">
                                            <div class="item-type10 text-left relative">
                                                <?php if ( has_post_thumbnail() ) : ?>
                                                    <div class="img-test">
                                                        <?php the_post_thumbnail( 'full' );?>
                                                    </div>
                                                <?php else : ?>
                                                    <div class="boxtm-img"></div>
                                                <?php endif; ?>
                                                <div class="txt">
                                                    <?php echo modus_content_limit(25); ?>
                                                </div>
                                                <div class="info">
                                                    <h3><?php the_title(); ?></h3>
                                                    <?php if ( $hidden_job != 'enable_hidden_job' ) : ?><span>- <?php echo get_post_meta( get_the_ID(), 'business', true );?></span> <?php endif; ?></h3>
                                                </div>
                                            </div>
                                        </div>
                                    <?php  endwhile; ?>
                                    <?php ?>
                                </div>
                            </div>
                            <?php
                            if ( ($layout == 'layout4') || ($layout == 'layout5') || ($layout == 'layout8') ){?>
                                <a class="btn-prev" href="#"><i class="fa fa-angle-left"></i></a>
                                <a class="btn-next" href="#"><i class="fa fa-angle-right"></i></a>
                            <?php }else { ?>
                                <div class="beans-pagination">
                                    <!-- pagination generated here -->
                                </div>
                            <?php } ?>
                        </div>
                    </div>
                <?php
                endif;?>

            <?php
            endif;
            ?>
        </div>
    </div>
    <?php
    return ob_get_clean();
}
?>